using System;
using System.Linq;

namespace takkvalifikacije
{
    class Program
    {
        static void Main()
        {
            int N, K; int[] input;

            input = Console.ReadLine().Split(' ').Select(v => int.Parse(v)).ToArray();
            N = input[0];
            K = input[1];

            int[] poljeSirina = new int[K];
            int pogodnihPolja = K;

            for (int i = 0; i < N; i++)
            {
                input = Console.ReadLine().Split(' ').Select(v => int.Parse(v)).ToArray();
                for (int j = 0; j < N; j++)
                {
                    int poljeTip = input[j];
                    int iStart = i, iEnd = i;
                    while (iEnd < N && input[++iEnd] == poljeTip) ;
                    if (i == 0)
                        poljeSirina[poljeTip] = iEnd - iStart;
                    else if (poljeSirina[poljeTip] != -1 && poljeSirina[poljeTip] != iEnd - iStart)
                    {
                        poljeSirina[poljeTip] = -1;
                        pogodnihPolja--;
                    }
                }
            }
            Console.WriteLine(pogodnihPolja);
            Console.ReadKey();
        }
    }
}